#include <stdio.h>
#include <math.h>
#include <rnd/fgetline.c>
#include <rnd/explode.c>
#include <rnd/filestring.c>
#include <rnd/eithertime.c>
#include <rnd/strconcat.c>
#include <rnd/streqi.c>
#include <rnd/strichr.c>
#include <rnd/foreachdirin.c>
#include <readconfig.c>
#include <rnd/trim.c>

char **filters,**searchroots,**excludepaths,*filenametemplate,*drives;

void paths_config(const char *filename)
{
	int n; LSet conf=readconfig(filename);
	filters=explode(",",configget(conf,"Extensions"));
	for (n=explodesegs(filters)-1;n>=0;n--) trim(filters[n]);
	searchroots=explode(",",configget(conf,"Search roots"));
	for (n=explodesegs(searchroots)-1;n>=0;n--) trim(searchroots[n]);
	excludepaths=explode(",",configget(conf,"Excluded paths"));
	for (n=explodesegs(excludepaths)-1;n>=0;n--) trim(excludepaths[n]);
	streqi(&filenametemplate,configget(conf,"Backup filename template"));
	freeconfig(conf);
	streqi(&drives,"c"); char *s,sc[2]; sc[1]=0;
	for (n=explodesegs(searchroots)-1;n>=0;n--)
	{
		s=searchroots[n];
		if (s[1]==':') if (!strichr(drives,s[0])) {sc[0]=s[0]; strconcat(&drives,sc);}
	}
}

int strcmpifn(const char **a,const char **b) {return strcmpi(*a,*b);}

void genfilelist_inner(const char *path,FILE *out)
{
	int n;
	for (n=explodesegs(excludepaths)-1;n>=0;n--) if (!strcmpi(path,excludepaths[n])) return;
	LSet files=LSet(char *);
	for (n=explodesegs(filters)-1;n>=0;n--)
	{
		int l=strlen(path); char *str,*bar=NULL;
		if (bar=strchr(filters[n],'|')) *bar=0;
		streqi(&str,path); strconcat(&str,"\\"); strconcat(&str,filters[n]);
		if (bar) {*bar='|'; if (!striseg(path,bar+1)) continue;}
		WIN32_FIND_DATA fd;
		HANDLE h=FindFirstFile(str,&fd);
		str[l+1]=0; // str is now "some\\dir\\"
		while (h!=INVALID_HANDLE_VALUE) // Search loop
		{
			if (!(fd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)) // No, we don't want to parse dirs
			{
				char *filestr=(char *)malloc(l+1+strlen(fd.cFileName)+1);
				strcpy(filestr,str[1]==':'?str+3:str); strcat(filestr,fd.cFileName);
				// fd.cFileName is "mallards.txt" and filestr is "some\\dir\\mallards.txt"
				LSet_add(&files,&filestr);
			}
			if (FindNextFile(h,&fd)==0) {FindClose(h); h=INVALID_HANDLE_VALUE;}
		}
		free(str);
	}
	// Remove duplicates (if todo.c matches both todo.* and *.c for example)
	LSet_qsort(&files,strcmpifn);
	char **f=(char **)files.a;
	for (n=0;n<files.m;n++) if (n==0 || strcmpi(f[n],f[n-1])) fprintf(out,"%s\n",f[n]);
	for (n=files.m-1;n>=0;n--) free(f[n]);
	LSet_free(files);
	foreachdirin(path,genfilelist_inner,out);
}

void genfilelist(const char *filename,const char drive)
{
	FILE *out=fopen(filename,"wt"); char *s;
	for (int n=explodesegs(searchroots)-1;n>=0;n--)
	{
		s=searchroots[n];
		if (s[1]!=':' || lc(s[0])==lc(drive)) genfilelist_inner(s,out);
	}
	fclose(out);
}

#include <rnd/sjbday.c>
#include <rnd/GetConsoleHwnd.c>
#include "c:/sjb39/@noupload/sborguserpass.c"

void main(void)
{
	CloseWindow(GetConsoleHwnd());
	char home[250]; GetCurrentDirectory(250,home); // OK, but needs Task Scheduler to make this start in its own directory
	paths_config("config.txt");
	//system("PATH=\"C:\\Program Files\\7-Zip\""); // Doesn't help
	char str[250],fold[250],fnew[250]; int d=floor(sjbday());
	sprintf(fold,filenametemplate,d-3);
	sprintf(fnew,filenametemplate,d);
	for (char *drive=drives;*drive;drive++)
	{
		sprintf(str,"%s\\files.txt",home); genfilelist(str,*drive);
		sprintf(str,"%c:\\",*drive); SetCurrentDirectory(str);
		sprintf(str,"\"C:\\Program Files\\7-Zip\\7z\" a -ms=on -mx=9 %s\\arc\\%s @%s\\files.txt -scsWIN",home,fnew,home);
		system(str);
	}
	free(home);
	//sprintf(str,"ncftpput "SBORGUSERPASS" stephenbrooks.org backup arc\\R%d.7z",d); system(str); // Relies on ncFTP
	FILE *out=fopen("script.ftp","wt");
	fprintf(out,"open stephenbrooks.org\n\
"SBORGUSER"\n\
"SBORGPASS"\n\
prompt\n\
hash\n\
lcd %s/arc\n\
cd /backup\n\
binary\n\
put %s\n\
del %s\n\
quit",home,fnew,fold);
	fclose(out);
	system("ftp -s:script.ftp");
	system("del script.ftp");
}
